## mingw-w64-libc%2B%2B-20.1.2-1.src.tar.zst

=== clang/lib/CodeGen/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  AggressiveInstCombine
  Analysis
  BitReader
  BitWriter
  CodeGenTypes
  Core
  Coroutines
  Coverage
  Demangle
  Extensions
  FrontendDriver
  FrontendHLSL
  FrontendOpenMP
  FrontendOffloading
  HIPStdPar
  IPO
  IRPrinter
  IRReader
  InstCombine
  Instrumentation
  LTO
  Linker
  MC
  ObjCARCOpts
  Object
  Passes
  ProfileData
  ScalarOpts
  Support
  Target
  TargetParser
  TransformUtils
  )

# Workaround for MSVC ARM64 performance regression:
# https://developercommunity.visualstudio.com/t/Compiling-a-specific-code-for-ARM64-with/10444970
# Since /O1 and /O2 represent a set of optimizations,
# our goal is to disable the /Og flag while retaining the other optimizations from the /O1|/O2 set
if(MSVC AND NOT CMAKE_CXX_COMPILER_ID MATCHES Clang
    AND MSVC_VERSION VERSION_GREATER_EQUAL 1932
    AND MSVC_VERSION VERSION_LESS 1939
    AND CMAKE_SYSTEM_PROCESSOR MATCHES "ARM64")

  string(TOUPPER "${CMAKE_BUILD_TYPE}" uppercase_CMAKE_BUILD_TYPE)
  string(REGEX MATCHALL "/[Oo][12]" opt_flags "${CMAKE_CXX_FLAGS} ${CMAKE_CXX_FLAGS_${uppercase_CMAKE_BUILD_TYPE}}")
  if (opt_flags)
    if(opt_flags MATCHES "1$")
      set(opt_flags "/Od;/Os;/Oy;/Ob2;/GF;/Gy")
    elseif (opt_flags MATCHES "2$")
      set(opt_flags "/Od;/Oi;/Ot;/Oy;/Ob2;/GF;/Gy")
    endif()
    set_source_files_properties(CGBuiltin.cpp PROPERTIES COMPILE_OPTIONS "${opt_flags}")
  endif()
endif()

add_clang_library(clangCodeGen
  ABIInfo.cpp
  ABIInfoImpl.cpp
  BackendUtil.cpp
  CGAtomic.cpp
  CGBlocks.cpp
  CGBuiltin.cpp
  CGCUDANV.cpp
  CGCUDARuntime.cpp
  CGCXX.cpp
  CGCXXABI.cpp
  CGCall.cpp
  CGClass.cpp
  CGCleanup.cpp
  CGCoroutine.cpp
  CGDebugInfo.cpp
  CGDecl.cpp
  CGDeclCXX.cpp
  CGException.cpp
  CGExpr.cpp
  CGExprAgg.cpp
  CGExprCXX.cpp
  CGExprComplex.cpp
  CGExprConstant.cpp
  CGExprScalar.cpp
  CGGPUBuiltin.cpp
  CGHLSLRuntime.cpp
  CGLoopInfo.cpp
  CGNonTrivialStruct.cpp
  CGObjC.cpp
  CGObjCGNU.cpp
  CGObjCMac.cpp
  CGObjCRuntime.cpp
  CGOpenCLRuntime.cpp
  CGOpenMPRuntime.cpp
  CGOpenMPRuntimeGPU.cpp
  CGPointerAuth.cpp
  CGRecordLayoutBuilder.cpp
  CGStmt.cpp
  CGStmtOpenMP.cpp
  CGVTT.cpp
  CGVTables.cpp
  CodeGenABITypes.cpp
  CodeGenAction.cpp
  CodeGenFunction.cpp
  CodeGenModule.cpp
  CodeGenPGO.cpp
  CodeGenTBAA.cpp
  CodeGenTypes.cpp
  ConstantInitBuilder.cpp
  CoverageMappingGen.cpp
  ItaniumCXXABI.cpp
  LinkInModulesPass.cpp
  MacroPPCallbacks.cpp
  MicrosoftCXXABI.cpp
  ModuleBuilder.cpp
  ObjectFilePCHContainerWriter.cpp
  PatternInit.cpp
  SanitizerMetadata.cpp
  SwiftCallingConv.cpp
  TargetInfo.cpp
  Targets/AArch64.cpp
  Targets/AMDGPU.cpp
  Targets/ARC.cpp
  Targets/ARM.cpp
  Targets/AVR.cpp
  Targets/BPF.cpp
  Targets/CSKY.cpp
  Targets/DirectX.cpp
  Targets/Hexagon.cpp
  Targets/Lanai.cpp
  Targets/LoongArch.cpp
  Targets/M68k.cpp
  Targets/MSP430.cpp
  Targets/Mips.cpp
  Targets/NVPTX.cpp
  Targets/PNaCl.cpp
  Targets/PPC.cpp
  Targets/RISCV.cpp
  Targets/SPIR.cpp
  Targets/Sparc.cpp
  Targets/SystemZ.cpp
  Targets/TCE.cpp
  Targets/VE.cpp
  Targets/WebAssembly.cpp
  Targets/X86.cpp
  Targets/XCore.cpp
  VarBypassDetector.cpp

  DEPENDS
  vt_gen
  intrinsics_gen
  ClangDriverOptions
  # These generated headers are included transitively.
  ARMTargetParserTableGen
  AArch64TargetParserTableGen

  LINK_LIBS
  clangAST
  clangAnalysis
  clangBasic
  clangFrontend
  clangLex
  clangSerialization
  )

=== clang/lib/Driver/CMakeLists.txt ===
set(LLVM_LINK_COMPONENTS
  BinaryFormat
  MC
  Object
  Option
  ProfileData
  Support
  TargetParser
  WindowsDriver
  )

if(WIN32)
  # MSVCToolChain.cpp uses version.dll.
  set(system_libs version)
endif()

add_clang_library(clangDriver
  Action.cpp
  Compilation.cpp
  Distro.cpp
  Driver.cpp
  DriverOptions.cpp
  Job.cpp
  Multilib.cpp
  MultilibBuilder.cpp
  OffloadBundler.cpp
  OptionUtils.cpp
  Phases.cpp
  SanitizerArgs.cpp
  Tool.cpp
  ToolChain.cpp
  ToolChains/Arch/AArch64.cpp
  ToolChains/Arch/ARM.cpp
  ToolChains/Arch/CSKY.cpp
  ToolChains/Arch/LoongArch.cpp
  ToolChains/Arch/M68k.cpp
  ToolChains/Arch/Mips.cpp
  ToolChains/Arch/PPC.cpp
  ToolChains/Arch/RISCV.cpp
  ToolChains/Arch/Sparc.cpp
  ToolChains/Arch/SystemZ.cpp
  ToolChains/Arch/VE.cpp
  ToolChains/Arch/X86.cpp
  ToolChains/AIX.cpp
  ToolChains/AMDGPU.cpp
  ToolChains/AMDGPUOpenMP.cpp
  ToolChains/AVR.cpp
  ToolChains/BareMetal.cpp
  ToolChains/Clang.cpp
  ToolChains/CommonArgs.cpp
  ToolChains/CrossWindows.cpp
  ToolChains/CSKYToolChain.cpp
  ToolChains/Cuda.cpp
  ToolChains/Darwin.cpp
  ToolChains/DragonFly.cpp
  ToolChains/Flang.cpp
  ToolChains/FreeBSD.cpp
  ToolChains/Fuchsia.cpp
  ToolChains/Gnu.cpp
  ToolChains/Haiku.cpp
  ToolChains/HIPUtility.cpp
  ToolChains/HIPAMD.cpp
  ToolChains/HIPSPV.cpp
  ToolChains/Hexagon.cpp
  ToolChains/HLSL.cpp
  ToolChains/Hurd.cpp
  ToolChains/Linux.cpp
  ToolChains/MipsLinux.cpp
  ToolChains/MinGW.cpp
  ToolChains/MSP430.cpp
  ToolChains/MSVC.cpp
  ToolChains/NaCl.cpp
  ToolChains/NetBSD.cpp
  ToolChains/OHOS.cpp
  ToolChains/OpenBSD.cpp
  ToolChains/PS4CPU.cpp
  ToolChains/RISCVToolchain.cpp
  ToolChains/Solaris.cpp
  ToolChains/SPIRV.cpp
  ToolChains/SPIRVOpenMP.cpp
  ToolChains/SYCL.cpp
  ToolChains/TCE.cpp
  ToolChains/UEFI.cpp
  ToolChains/VEToolchain.cpp
  ToolChains/WebAssembly.cpp
  ToolChains/XCore.cpp
  ToolChains/PPCLinux.cpp
  ToolChains/PPCFreeBSD.cpp
  ToolChains/InterfaceStubs.cpp
  ToolChains/ZOS.cpp
  Types.cpp
  XRayArgs.cpp

  DEPENDS
  ClangDriverOptions
  # These generated headers are included transitively.
  ARMTargetParserTableGen
  AArch64TargetParserTableGen

  LINK_LIBS
  clangBasic
  ${system_libs}
  )

=== libc/src/locale/CMakeLists.txt ===
add_object_library(
  locale
  SRCS
    locale.cpp
  HDRS
    locale.h
  DEPENDS
    libc.include.locale
)

add_entrypoint_object(
  localeconv
  SRCS
    localeconv.cpp
  HDRS
    localeconv.h
  DEPENDS
    libc.include.locale
  CXX_STANDARD
    20 # For designated initializers
)

add_entrypoint_object(
  newlocale
  SRCS
    newlocale.cpp
  HDRS
    newlocale.h
  DEPENDS
    libc.include.locale
    .locale
)

add_entrypoint_object(
  duplocale
  SRCS
    duplocale.cpp
  HDRS
    duplocale.h
  DEPENDS
    libc.include.locale
    .locale
)

add_entrypoint_object(
  setlocale
  SRCS
    setlocale.cpp
  HDRS
    setlocale.h
  DEPENDS
    libc.include.locale
    .locale
)

add_entrypoint_object(
  uselocale
  SRCS
    uselocale.cpp
  HDRS
    uselocale.h
  DEPENDS
    libc.include.locale
    .locale
)

add_entrypoint_object(
  freelocale
  SRCS
    freelocale.cpp
  HDRS
    freelocale.h
  DEPENDS
    libc.include.locale
    .locale
)

=== clang-tools-extra/clangd/benchmarks/CompletionModel/CMakeLists.txt ===
add_benchmark(DecisionForestBenchmark DecisionForestBenchmark.cpp)

target_link_libraries(DecisionForestBenchmark
  PRIVATE
  clangDaemon
  LLVMSupport
  )

=== libc/src/math/generic/CMakeLists.txt ===


add_entrypoint_object(
  canonicalize
  SRCS
    canonicalize.cpp
  HDRS
    ../canonicalize.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizef
  SRCS
    canonicalizef.cpp
  HDRS
    ../canonicalizef.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizef16
  SRCS
    canonicalizef16.cpp
  HDRS
    ../canonicalizef16.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizef128
  SRCS
    canonicalizef128.cpp
  HDRS
    ../canonicalizef128.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  canonicalizel
  SRCS
    canonicalizel.cpp
  HDRS
    ../canonicalizel.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.basic_operations
)

add_entrypoint_object(
  iscanonical
  SRCS
    iscanonical.cpp
  HDRS
    ../iscanonical.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  iscanonicalf
  SRCS
    iscanonicalf.cpp
  HDRS
    ../iscanonicalf.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  iscanonicall
  SRCS
    iscanonicall.cpp
  HDRS
    ../iscanonicall.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  iscanonicalf16
  SRCS
    iscanonicalf16.cpp
  HDRS
    ../iscanonicalf16.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
)

add_entrypoint_object(
  iscanonicalf128
  SRCS
    iscanonicalf128.cpp
  HDRS
    ../iscanonicalf128.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
)

add_entrypoint_object(
  ceil
  SRCS
    ceil.cpp
  HDRS
    ../ceil.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.nearest_integer_operations
  FLAGS
    ROUND_OPT
)

add_entrypoint_object(
  ceilf
  SRCS
    ceilf.cpp
  HDRS
    ../ceilf.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.nearest_integer_operations
  FLAGS
    ROUND_OPT
)

add_entrypoint_object(
  ceill
  SRCS
    ceill.cpp
  HDRS
    ../ceill.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.nearest_integer_operations
)

add_entrypoint_object(
  ceilf16
  SRCS
    ceilf16.cpp
  HDRS
    ../ceilf16.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.nearest_integer_operations
    libc.src.__support.macros.properties.cpu_features
    libc.src.__support.macros.properties.types
  FLAGS
    ROUND_OPT
)

add_entrypoint_object(
  ceilf128
  SRCS
    ceilf128.cpp
  HDRS
    ../ceilf128.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.nearest_integer_operations
)

add_entrypoint_object(
  daddl
  SRCS
    daddl.cpp
  HDRS
    ../daddl.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.generic.add_sub
)

add_entrypoint_object(
  daddf128
  SRCS
    daddf128.cpp
  HDRS
    ../daddf128.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
 DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.generic.add_sub
)

add_entrypoint_object(
  ddivl
  SRCS
    ddivl.cpp
  HDRS
    ../ddivl.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.FPUtil.generic.div
)

add_entrypoint_object(
  ddivf128
  SRCS
    ddivf128.cpp
  HDRS
    ../ddivf128.h
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.generic.div
)

add_entrypoint_object(
  dfmaf128
  SRCS
    dfmaf128.cpp
  HDRS
    ../dfmaf128.h
  DEPENDS
    libc.src.__support.FPUtil.fma
    libc.src.__support.macros.properties.types
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  dfmal
  SRCS
    dfmal.cpp
  HDRS
    ../dfmal.h
  DEPENDS
    libc.src.__support.FPUtil.fma
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  dsqrtl
  SRCS
    dsqrtl.cpp
  HDRS
    ../dsqrtl.h
  DEPENDS
    libc.src.__support.FPUtil.generic.sqrt
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  dsqrtf128
  SRCS
    dsqrtf128.cpp
  HDRS
    ../dsqrtf128.h
  DEPENDS
    libc.src.__support.macros.properties.types
    libc.src.__support.FPUtil.generic.sqrt
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)


add_entrypoint_object(
  dsubf128
  SRCS
    dsubf128.cpp
  HDRS
    ../dsubf128.h
  DEPENDS
    libc.src.__support.FPUtil.generic.add_sub
    libc.src.__support.macros.properties.types
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  dsubl
  SRCS
    dsubl.cpp
  HDRS
    ../dsubl.h
  DEPENDS
    libc.src.__support.FPUtil.generic.add_sub
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_header_library(
  range_reduction
  HDRS
    range_reduction.h
    range_reduction_fma.h
  DEPENDS
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.common
)

add_header_library(
  range_reduction_double
  HDRS
    range_reduction_double_common.h
    range_reduction_double_fma.h
    range_reduction_double_nofma.h
  DEPENDS
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.common
    libc.src.__support.integer_literals
)

add_header_library(
  sincosf_utils
  HDRS
    sincosf_utils.h
  DEPENDS
    .range_reduction
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.common
)

add_header_library(
  sincosf16_utils
  HDRS
    sincosf16_utils.h
  DEPENDS
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.nearest_integer
    libc.src.__support.common
)

add_header_library(
  sincos_eval
  HDRS
    sincos_eval.h
  DEPENDS
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.integer_literals
)

add_entrypoint_object(
  cos
  SRCS
    cos.cpp
  HDRS
    ../cos.h
  DEPENDS
    .range_reduction_double
    .sincos_eval
    libc.hdr.errno_macros
    libc.src.errno.errno
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  cosf
  SRCS
    cosf.cpp
  HDRS
    ../cosf.h
  DEPENDS
    .sincosf_utils
    libc.src.errno.errno
    libc.src.__support.FPUtil.basic_operations
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  cosf16
  SRCS
    cosf16.cpp
  HDRS
    ../cosf16.h
  DEPENDS
    .sincosf16_utils
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
)

add_entrypoint_object(
  cospif
  SRCS
    cospif.cpp
  HDRS
    ../cospif.h
  DEPENDS
    .sincosf_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  cospif16
  SRCS
    cospif16.cpp
  HDRS
    ../cospif16.h
  DEPENDS
    .sincosf16_utils
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sin
  SRCS
    sin.cpp
  HDRS
    ../sin.h
  DEPENDS
    .range_reduction_double
    .sincos_eval
    libc.hdr.errno_macros
    libc.src.errno.errno
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sinf
  SRCS
    sinf.cpp
  HDRS
    ../sinf.h
  DEPENDS
    .range_reduction
    .sincosf_utils
    libc.src.errno.errno
    libc.src.__support.FPUtil.basic_operations
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sinf16
  SRCS
    sinf16.cpp
  HDRS
    ../sinf16.h
  DEPENDS
    .sincosf16_utils
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
    libc.src.__support.macros.properties.types
  COMPILE_OPTIONS
    -O3
)

add_entrypoint_object(
  sincos
  SRCS
    sincos.cpp
  HDRS
    ../sincos.h
  DEPENDS
    .range_reduction_double
    .sincos_eval
    libc.hdr.errno_macros
    libc.src.errno.errno
    libc.src.__support.FPUtil.double_double
    libc.src.__support.FPUtil.dyadic_float
    libc.src.__support.FPUtil.except_value_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sinpif
  SRCS
    sinpif.cpp
  HDRS
    ../sinpif.h
  DEPENDS
    .sincosf_utils
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.common
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sincosf
  SRCS
    sincosf.cpp
  HDRS
    ../sincosf.h
  DEPENDS
    .range_reduction
    .sincosf_utils
    libc.src.errno.errno
    libc.src.__support.FPUtil.fenv_impl
    libc.src.__support.FPUtil.fp_bits
    libc.src.__support.FPUtil.fma
    libc.src.__support.FPUtil.multiply_add
    libc.src.__support.FPUtil.polyeval
    libc.src.__support.FPUtil.rounding_mode
    libc.src.__support.macros.optimization
  COMPILE_OPTIONS
    ${libc_opt_high_flag}
)

add_entrypoint_object(
  sinpif16
  SRCS
    sinpif16.cpp
  HDRS
    ../sinpif16.h
  DEPENDS
    .sincosf16_utils
    libc.hdr.errno_macros
    libc.hdr.fenv_macros
    libc.src.__support.FPUtil.cast

=== flang/include/flang/Optimizer/OpenMP/CMakeLists.txt ===
set(LLVM_TARGET_DEFINITIONS Passes.td)
mlir_tablegen(Passes.h.inc -gen-pass-decls -name FlangOpenMP)

add_public_tablegen_target(FlangOpenMPPassesIncGen)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

if [[ $MINGW_PACKAGE_PREFIX == *-clang-* ]]; then
  _clangprefix=1
fi

_realname=libc++
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}"
         "${MINGW_PACKAGE_PREFIX}-libunwind")
_pkgver=20.1.2
pkgver=${_pkgver/-/}
pkgrel=1
arch=(any)
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clangarm64')
url="https://libcxx.llvm.org/"
msys2_references=(
  "cpe: cpe:/a:llvm:llvm"
)
license=("spdx:Apache-2.0 WITH LLVM-exception")
groups=($( (( _clangprefix )) && echo "${MINGW_PACKAGE_PREFIX}-toolchain"))
makedepends=("${MINGW_PACKAGE_PREFIX}-clang"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-lld"
             $( (( _clangprefix )) && echo "${MINGW_PACKAGE_PREFIX}-compiler-rt")
             "${MINGW_PACKAGE_PREFIX}-python")
if [[ ${MINGW_PACKAGE_PREFIX} != *-clang-* ]]; then
  # GNU's strip breaks the library #11553
  options=('!strip')
fi
_url=https://github.com/llvm/llvm-project/releases/download/llvmorg-${_pkgver}
source=("${_url}/llvm-project-${_pkgver}.src.tar.xz"{,.sig})
sha256sums=('f0a4a240aabc9b056142d14d5478bb6d962aeac549cbd75b809f5499240a8b38'
            'SKIP')
validpgpkeys=('B6C8F98282B944E3B0D5C2530FC3042E345AD05D'  # Hans Wennborg, Google.
              '474E22316ABF4785A88C6E8EA2C794A986419D8A'  # Tom Stellard
              'D574BD5D1D0E98895E3BF90044F2485E45D59042') # Tobias Hieta
noextract=(llvm-project-${_pkgver}.src.tar.xz)

prepare() {
  plain "Extracting llvm-project-${_pkgver}.src.tar.xz due to symlink(s) without pre-existing target(s)"
  tar -xJf "${srcdir}"/llvm-project-${_pkgver}.src.tar.xz -C "${srcdir}" || true
}

build() {
  mkdir -p build-${MSYSTEM} && cd build-${MSYSTEM}

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if (( _clangprefix )); then
    _extra_config+=(
      -DLIBCXX_USE_COMPILER_RT=ON
      -DLIBCXXABI_USE_COMPILER_RT=ON
      -DLIBCXXABI_USE_LLVM_UNWINDER=ON
      -DLIBCXXABI_ENABLE_STATIC_UNWINDER=ON
      -DLIBUNWIND_USE_COMPILER_RT=ON
    )
  else
    _extra_config+=(-DLIBCXXABI_USE_LLVM_UNWINDER=OFF)
  fi

  # Targeting Win 7 will just lead to libc++ looking
  # up new APIs at runtime, so there is no downside really
  local _win32_winnt
  if [[ ${MSYSTEM} == CLANGARM64 ]]; then
      _win32_winnt=0xA00 # Windows 10
  else
      _win32_winnt=0x601 # Windows 7
  fi

  CC=${MINGW_PREFIX}/bin/clang.exe \
  CXX=${MINGW_PREFIX}/bin/clang++.exe \
  CXXFLAGS+=" -D_WIN32_WINNT=${_win32_winnt} $CPPFLAGS" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  ${MINGW_PREFIX}/bin/cmake.exe \
    -GNinja \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_SYSTEM_IGNORE_PATH=/usr/lib \
    -DCMAKE_AR="${MINGW_PREFIX}/bin/llvm-ar.exe" \
    -DCMAKE_ASM_COMPILER="${MINGW_PREFIX}/bin/clang.exe" \
    -DCMAKE_RANLIB="${MINGW_PREFIX}/bin/llvm-ranlib.exe" \
    -DLLVM_HOST_TRIPLE="${CARCH}-w64-windows-gnu" \
    -DLLVM_ENABLE_LLD=ON \
    -DLLVM_ENABLE_RUNTIMES="libcxx;libcxxabi;libunwind" \
    -DLIBCXX_ENABLE_SHARED=ON \
    -DLIBCXX_ENABLE_STATIC=ON \
    -DLIBCXX_ENABLE_STATIC_ABI_LIBRARY=ON \
    -DLIBCXX_HAS_WIN32_THREAD_API=ON \
    -DLIBCXX_INSTALL_MODULES=ON \
    -DLIBCXX_INCLUDE_BENCHMARKS=OFF \
    -DLIBCXXABI_ENABLE_SHARED=OFF \
    -DLIBCXXABI_ENABLE_STATIC=ON \
    -DLIBCXXABI_HAS_WIN32_THREAD_API=ON \
    -DLIBUNWIND_ENABLE_FRAME_APIS=ON \
    -DLIBUNWIND_ENABLE_SHARED=ON \
    -DLIBUNWIND_ENABLE_STATIC=ON \
    -DENABLE_TIME_ZONE_DATABASE_DEFAULT=ON \
    -DLLVM_INCLUDE_TESTS=OFF \
    "${_extra_config[@]}" \
    -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
    -Wno-dev \
    ../llvm-project-${_pkgver}.src/runtimes

  ${MINGW_PREFIX}/bin/cmake --build . -- unwind cxxabi cxx cxx_experimental
}

package_libc++() {
  pkgdesc="C++ Standard Library (mingw-w64)"
  url="https://libcxx.llvm.org/"
  provides=("${MINGW_PACKAGE_PREFIX}-libc++abi"
            $( (( _clangprefix )) && echo \
             "${MINGW_PACKAGE_PREFIX}-gcc-libs" \
             || true))
  depends=($( (( _clangprefix )) && echo \
             "${MINGW_PACKAGE_PREFIX}-libunwind" \
             || echo "${MINGW_PACKAGE_PREFIX}-gcc-libs"))

  DESTDIR="${pkgdir}" ${MINGW_PREFIX}/bin/cmake --build "${srcdir}/build-${MSYSTEM}" --target install-cxx install-cxxabi

  install -Dm644 "${srcdir}"/llvm-project-${_pkgver}.src/libcxx/LICENSE.TXT \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/libc++/LICENSE
}

package_libunwind() {
  pkgdesc='A new implementation of a stack unwinder for C++ exceptions (mingw-w64)'
  url='https://llvm.org/'
  depends=($( (( _clangprefix )) || echo "${MINGW_PACKAGE_PREFIX}-gcc-libs"))

  DESTDIR="${pkgdir}" cmake --build "${srcdir}/build-${MSYSTEM}" --target install-unwind

  install -Dm644 "${srcdir}"/llvm-project-${_pkgver}.src/libunwind/LICENSE.TXT \
    "${pkgdir}"${MINGW_PREFIX}/share/licenses/libunwind/LICENSE
}

# template start; name=mingw-w64-splitpkg-wrappers; version=1.0;
# vim: set ft=bash :

# generate wrappers
for _name in "${pkgname[@]}"; do
  _short="package_${_name#${MINGW_PACKAGE_PREFIX}-}"
  _func="$(declare -f "${_short}")"
  eval "${_func/#${_short}/package_${_name}}"
done
# template end;
